#! /usr/bin/env python
############################################################################
# Description: Generates a valide date of 360 days
#
#
# Usage : date_360d year, month, day
#      " -h, --help    : print a help message
#      " -v, --version : print the name and the version of the application
#
# Can be called interactively with:
# python date_360d 1998 12 29
# >> 1998 12 29
# or
# date_360d 1998 12 29
# >> 1998 12 29
#
# Can be import with:
# from date_360d import date_360d
# print date_360d(1998,12,29) 
# >> (1998,12,29)
#
# Author: Sylvain CASTELOT
# Contact: sylvain.castelot@ipsl.jussieu.fr
# $Date: 2003/06/30 15:22:47 $
# $Name: ipsl_cm4_v1_6 $
# $Revision: 1.1 $
#############################################################################
from sys import *
import getopt

def _usage():
    print 'usage: date_360d year month day\n\t-h, --help\t\tprint this help\n\t-v, --version\t\tprint the name and the version of the software'

def _version():
    print "date_360d 1.0\nWritten by Sylvain Castelot 2003"


def date_360d(y,m,d):
    try:
        d=int(d)-1
        m=int(m)-1
        return (d/30+m)/12+int(y),(d/30+m)%12+1,d%30+1
    except ValueError:
        return 0
        
        
if __name__ == '__main__':
    try:
        opts, args = getopt.getopt(argv[1:], "hv", ["help","version"])
    except getopt.GetoptError:
        _usage()
        exit(2)
    for o ,a in opts:
        if o in ("-h", "--help"):
            _usage()
            exit(2)
        if o in ("-v","--version"):
            _version()
            exit(1)
    try:
        r=date_360d(args[0],args[1],args[2])
        if not r:
            _usage()
            exit(2)
        print r[0],r[1],r[2]
    except IndexError:
        _usage()
        exit(1)
